## xbyak 6.00

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6...3.0.2)

project(xbyak LANGUAGES CXX VERSION 6.00)

file(GLOB headers xbyak/*.h)

if (DEFINED CMAKE_VERSION AND CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.2)
	include(GNUInstallDirs)
	add_library(${PROJECT_NAME} INTERFACE)
	add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})
	
	target_include_directories(
		${PROJECT_NAME} INTERFACE
		"$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
		"$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
	)

	install(
		TARGETS ${PROJECT_NAME}
		EXPORT ${PROJECT_NAME}-targets
		INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}
	)

	include(CMakePackageConfigHelpers)
	configure_package_config_file(
		cmake/config.cmake.in
		"${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
		INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
	)
	write_basic_package_version_file(
		"${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
		COMPATIBILITY SameMajorVersion
	)

	install(
		FILES
			"${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
			"${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
		DESTINATION
			${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
	)

	install(
		EXPORT ${PROJECT_NAME}-targets
		NAMESPACE ${PROJECT_NAME}::
		DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
	)
elseif(NOT DEFINED CMAKE_INSTALL_INCLUDEDIR)
	set(CMAKE_INSTALL_INCLUDEDIR "include")
endif()

install(
	FILES ${headers}
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xbyak
)

=== gen/Makefile ===
TARGET=../xbyak/xbyak_mnemonic.h
BIN=sortline gen_code gen_avx512
CFLAGS=-I../ -O2 -DXBYAK_NO_OP_NAMES -Wall -Wextra -Wno-missing-field-initializers
all: $(TARGET) ../CMakeLists.txt
sortline: sortline.cpp
	$(CXX) $(CFLAGS) $< -o $@
gen_code: gen_code.cpp ../xbyak/xbyak.h avx_type.hpp
	$(CXX) $(CFLAGS) $< -o $@
gen_avx512: gen_avx512.cpp ../xbyak/xbyak.h avx_type.hpp
	$(CXX) $(CFLAGS) $< -o $@

$(TARGET): $(BIN)
	./gen_code | ./sortline > $@
	echo "#ifdef XBYAK_ENABLE_OMITTED_OPERAND" >> $@
	./gen_code omit | ./sortline >> $@
	echo "#endif" >>$@
	./gen_code fixed >> $@
	echo "#ifndef XBYAK_DISABLE_AVX512" >> $@
	./gen_avx512 | ./sortline >> $@
	echo "#ifdef XBYAK64" >> $@
	./gen_avx512 64 | ./sortline >> $@
	echo "#endif" >> $@
	echo "#endif" >> $@

VER=$(shell head -n 1 ../xbyak/xbyak_mnemonic.h|grep -o "[0-9.]*")
../CMakeLists.txt: $(TARGET)
	sed -i -e 's/CXX VERSION [0-9.]*/CXX VERSION $(VER)/' ../CMakeLists.txt

clean:
	$(RM) $(BIN) $(TARGET)

## xbyak 6.01

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.00)
+project(xbyak LANGUAGES CXX VERSION 6.01)
 
 file(GLOB headers xbyak/*.h)

=== debian/changelog ===
xbyak (6.01-1) unstable; urgency=medium

  * New upstream version 6.01
  * d/control: add Vcs fields
  * d/patches: drop upstreamed patches

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 12 Jan 2022 23:11:02 +0100

xbyak (6.00-2) unstable; urgency=medium

  * Backport b29e471 (CMake Config file include path fix)
  * d/control: remove Vcs-* fields, as no vcs is used
  * d/upstream/metadata: update Documentation and Changelog fields
  * d/watch: use /tags instead of /releases

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 20 Nov 2021 22:04:30 +0100

xbyak (6.00-1) unstable; urgency=low

  * Initial release. Closes: #995760

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 05 Oct 2021 10:29:03 +0200

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v@ANY_VERSION@\.tar\.gz/@PACKAGE@-$1\.tar\.gz/, \
  pgpmode=none" \
https://github.com/herumi/@PACKAGE@/tags .*/v@ANY_VERSION@\.tar\.gz debian uupdate

## xbyak 6.02

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.01)
+project(xbyak LANGUAGES CXX VERSION 6.02)
 
 file(GLOB headers xbyak/*.h)

=== gen/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 TARGET=../xbyak/xbyak_mnemonic.h
 BIN=sortline gen_code gen_avx512
 CFLAGS=-I../ -O2 -DXBYAK_NO_OP_NAMES -Wall -Wextra -Wno-missing-field-initializers
-all: $(TARGET) ../CMakeLists.txt
+all: $(TARGET) ../CMakeLists.txt ../meson.build
 sortline: sortline.cpp
 	$(CXX) $(CFLAGS) $< -o $@
 gen_code: gen_code.cpp ../xbyak/xbyak.h avx_type.hpp
@@ -24,7 +24,10 @@
 
 VER=$(shell head -n 1 ../xbyak/xbyak_mnemonic.h|grep -o "[0-9.]*")
 ../CMakeLists.txt: $(TARGET)
-	sed -i -e 's/CXX VERSION [0-9.]*/CXX VERSION $(VER)/' ../CMakeLists.txt
+	sed -i -e 's/CXX VERSION [0-9.]*/CXX VERSION $(VER)/' $@
+
+../meson.build: $(TARGET)
+	sed -i -e "s/version: '[0-9.]*',/version: '$(VER)',/" $@
 
 clean:
 	$(RM) $(BIN) $(TARGET)

=== sample/Makefile ===
XBYAK_INC=../xbyak/xbyak.h

BOOST_EXIST=$(shell echo "\#include <boost/spirit/core.hpp>" | (gcc -E - 2>/dev/null) | grep "boost/spirit/core.hpp" >/dev/null && echo "1")
UNAME_M=$(shell uname -m)

ONLY_64BIT=0
ifeq ($(shell uname -s),Darwin)
	ONLY_64BIT=1
	OS=mac
	ifeq ($(UNAME_M),x86_64)
		BIT=64
	endif
	ifeq ($(UNAME_M),i386)
		BIT=32
	endif
	ifeq ($(shell sw_vers -productVersion | cut -c1-4 | sed 's/\.//'),105)
		ifeq ($(shell sysctl -n hw.cpu64bit_capable),1)
			BIT=64
		endif
	endif
else
	BIT=32
	ifeq ($(UNAME_M),x86_64)
		BIT=64
	endif
	ifeq ($(UNAME_M),amd64)
		BIT=64
	endif
endif

ifeq ($(BIT),64)
TARGET += test64 bf64 memfunc64 test_util64 jmp_table64
ifeq ($(BOOST_EXIST),1)
TARGET += calc64 #calc2_64
endif
endif

ifneq ($(OS),mac)
TARGET += static_buf64
endif


ifneq ($(ONLY_64BIT),1)
	TARGET += test quantize bf toyvm test_util memfunc static_buf jmp_table
ifeq ($(BOOST_EXIST),1)
	TARGET += calc #calc2
endif
endif

all: $(TARGET)

CFLAGS_WARN=-Wall -Wextra -Wformat=2 -Wcast-qual -Wcast-align -Wwrite-strings -Wfloat-equal -Wpointer-arith #-pedantic

CFLAGS=-g -O2 -fomit-frame-pointer -Wall -I../ $(CFLAGS_WARN)

test:
	$(CXX) $(CFLAGS) test0.cpp -o $@ -m32

quantize:
	$(CXX) $(CFLAGS) quantize.cpp -o $@ -m32

calc:
	$(CXX) $(CFLAGS) calc.cpp -o $@ -m32
calc64:
	$(CXX) $(CFLAGS) calc.cpp -o $@ -m64
calc2:
	$(CXX) $(CFLAGS) calc2.cpp -o $@ -m32
calc2_64:
	$(CXX) $(CFLAGS) calc2.cpp -o $@ -m64

bf:
	$(CXX) $(CFLAGS) bf.cpp -o $@ -m32
bf64:
	$(CXX) $(CFLAGS) bf.cpp -o $@ -m64

memfunc:
	$(CXX) $(CFLAGS) memfunc.cpp -o $@ -m32
memfunc64:
	$(CXX) $(CFLAGS) memfunc.cpp -o $@ -m64

toyvm:
	$(CXX) $(CFLAGS) toyvm.cpp -o $@ -m32

test64:
	$(CXX) $(CFLAGS) test0.cpp -o $@ -m64
test_util:
	$(CXX) $(CFLAGS) test_util.cpp -o $@ -m32
test_util64:
	$(CXX) $(CFLAGS) test_util.cpp -o $@ -m64
static_buf:
	$(CXX) $(CFLAGS) static_buf.cpp -o $@ -m32
static_buf64:
	$(CXX) $(CFLAGS) static_buf.cpp -o $@ -m64
jmp_table:
	$(CXX) $(CFLAGS) jmp_table.cpp -o $@ -m32
jmp_table64:
	$(CXX) $(CFLAGS) jmp_table.cpp -o $@ -m64
profiler: profiler.cpp ../xbyak/xbyak_util.h
	$(CXX) $(CFLAGS) profiler.cpp -o $@
profiler-vtune: profiler.cpp ../xbyak/xbyak_util.h
	$(CXX) $(CFLAGS) profiler.cpp -o $@ -DXBYAK_USE_VTUNE -I /opt/intel/vtune_amplifier/include/ -L /opt/intel/vtune_amplifier/lib64 -ljitprofiling -ldl

clean:
	rm -rf *.o $(TARGET) *.exe profiler profiler-vtune

test : test0.cpp $(XBYAK_INC)
test64: test0.cpp $(XBYAK_INC)
quantize : quantize.cpp $(XBYAK_INC)
calc : calc.cpp $(XBYAK_INC)
calc64 : calc.cpp $(XBYAK_INC)
calc2 : calc2.cpp $(XBYAK_INC)
calc2_64 : calc2.cpp $(XBYAK_INC)
bf : bf.cpp $(XBYAK_INC)
bf64 : bf.cpp $(XBYAK_INC)
memfunc : memfunc.cpp $(XBYAK_INC)
memfunc64 : memfunc.cpp $(XBYAK_INC)
toyvm : toyvm.cpp $(XBYAK_INC)
static_buf: static_buf.cpp $(XBYAK_INC)
static_buf64: static_buf.cpp $(XBYAK_INC)
test_util : test_util.cpp $(XBYAK_INC) ../xbyak/xbyak_util.h
test_util2 : test_util.cpp $(XBYAK_INC) ../xbyak/xbyak_util.h
jmp_table: jmp_table.cpp $(XBYAK_INC)
jmp_table64: jmp_table.cpp $(XBYAK_INC)

=== debian/changelog ===
xbyak (6.02-1) unstable; urgency=medium

  * New upstream version 6.02

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 13 Feb 2022 22:40:01 +0100

=== debian/control ===
Source: xbyak
Section: libdevel
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends: debhelper-compat (= 13),
               meson (>= 0.50),
               cmake
Standards-Version: 4.6.0
Homepage: https://github.com/herumi/xbyak
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/xbyak.git
Vcs-Browser: https://salsa.debian.org/debian/xbyak

Package: libxbyak-dev
Architecture: any-amd64 any-i386
Depends: ${misc:Depends}
Description: JIT assembler for x86(IA32), x64(AMD64, x86-64)
 Xbyak is a C++ header library that enables dynamically to assemble
 x86(IA32), x64(AMD64, x86-64) mnemonic.
 .
 The library supports any compiler supporting C++03 or later.
 .
 This package contains the development headers.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=+all

%:
	dh $@ --buildsystem=meson

## xbyak 6.04

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.02)
+project(xbyak LANGUAGES CXX VERSION 6.04)
 
 file(GLOB headers xbyak/*.h)

=== gen/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 TARGET=../xbyak/xbyak_mnemonic.h
 BIN=sortline gen_code gen_avx512
-CFLAGS=-I../ -O2 -DXBYAK_NO_OP_NAMES -Wall -Wextra -Wno-missing-field-initializers
+CFLAGS=-I../ -O2 -DXBYAK_NO_OP_NAMES -Wall -Wextra -Wno-missing-field-initializers $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS)
 all: $(TARGET) ../CMakeLists.txt ../meson.build
 sortline: sortline.cpp
 	$(CXX) $(CFLAGS) $< -o $@

## xbyak 6.052

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.04)
+project(xbyak LANGUAGES CXX VERSION 6.052)
 
 file(GLOB headers xbyak/*.h)

=== debian/changelog ===
xbyak (6.052-1) unstable; urgency=medium

  * New upstream version 6.052
  * d/upstream/metadata: update paths

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 26 May 2022 13:22:26 +0200

xbyak (6.04-1) unstable; urgency=medium

  * New upstream version 6.04
  * d/patches: drop upstreamed patches

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 18 Apr 2022 21:02:22 +0200

xbyak (6.03-1) unstable; urgency=medium

  * New upstream version 6.03
  * d/{control,rules}: build examples and run tests
  * d/tests: add autopkgtests

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 13 Mar 2022 00:48:30 +0100

## xbyak 6.60.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.052)
+project(xbyak LANGUAGES CXX VERSION 6.60.2)
 
 file(GLOB headers xbyak/*.h)

=== debian/changelog ===
xbyak (6.60.2-1) unstable; urgency=medium

  * New upstream version 6.60.2

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 16 Jun 2022 23:30:22 +0200

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,10 @@
 Build-Depends: debhelper-compat (= 13),
                meson (>= 0.50),
                cmake
+Build-Depends-Arch: g++-multilib <!nocheck>,
+                    libboost-dev <!nocheck>,
+                    nasm <!nocheck>,
+                    yasm <!nocheck>
 Standards-Version: 4.6.0
 Homepage: https://github.com/herumi/xbyak
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=+all
# -Werror=array-bounds: added by qa=+bug, triggers some false positives
export DEB_CXXFLAGS_MAINT_STRIP = -Werror=array-bounds

%:
	dh $@ --buildsystem=meson

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

ifeq ($(shell dpkg --print-architecture), i386)
  bits := 32
else
  bits := 64
endif

override_dh_auto_build-arch:
	dh_auto_build
	make -C sample BIT=$(bits)
	make -C test BIT=$(bits)

override_dh_auto_test:
	dh_auto_test
	uname -m
	dpkg --print-architecture
	make -C test BIT=$(bits) test

override_dh_auto_clean:
	dh_auto_clean
	make -C sample BIT=$(bits) clean
	make -C test BIT=$(bits) clean
	$(RM) gen/gen_avx512 gen/gen_code gen/sortline

endif

## xbyak 6.61.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.60.2)
+project(xbyak LANGUAGES CXX VERSION 6.61.2)
 
 file(GLOB headers xbyak/*.h)

=== debian/changelog ===
xbyak (6.61.2-1) unstable; urgency=medium

  * New upstream version 6.61.2

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 19 Aug 2022 00:56:44 +0200

## xbyak 6.63

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.61.2)
+project(xbyak LANGUAGES CXX VERSION 6.63)
 
 file(GLOB headers xbyak/*.h)

=== gen/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 TARGET=../xbyak/xbyak_mnemonic.h
 BIN=sortline gen_code gen_avx512
 CFLAGS=-I../ -O2 -DXBYAK_NO_OP_NAMES -Wall -Wextra -Wno-missing-field-initializers $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS)
-all: $(TARGET) ../CMakeLists.txt ../meson.build
+all: $(TARGET) ../CMakeLists.txt ../meson.build ../readme.md ../readme.txt
 sortline: sortline.cpp
 	$(CXX) $(CFLAGS) $< -o $@
 gen_code: gen_code.cpp ../xbyak/xbyak.h avx_type.hpp
@@ -29,5 +29,11 @@
 ../meson.build: $(TARGET)
 	sed -i -e "s/version: '[0-9.]*',/version: '$(VER)',/" $@
 
+../readme.md: $(TARGET)
+	sed -l 2 -i -e "s/# Xbyak [0-9.]*/# Xbyak $(VER)/" $@
+
+../readme.txt: $(TARGET)
+	sed -l 2 -i -e "s/Xbyak [0-9.]*/Xbyak $(VER)/" $@
+
 clean:
 	$(RM) $(BIN) $(TARGET)

=== sample/Makefile ===
--- 
+++ 
@@ -37,6 +37,7 @@
 
 ifneq ($(OS),mac)
 TARGET += static_buf64
+TARGET += memfd
 endif
 
 
@@ -51,7 +52,7 @@
 
 CFLAGS_WARN=-Wall -Wextra -Wformat=2 -Wcast-qual -Wcast-align -Wwrite-strings -Wfloat-equal -Wpointer-arith #-pedantic
 
-CFLAGS=-g -O2 -fomit-frame-pointer -Wall -I../ $(CFLAGS_WARN)
+CFLAGS=-g -O2 -fomit-frame-pointer -Wall -I../ $(CFLAGS_WARN) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS)
 
 test:
 	$(CXX) $(CFLAGS) test0.cpp -o $@ -m32
@@ -95,6 +96,8 @@
 	$(CXX) $(CFLAGS) jmp_table.cpp -o $@ -m32
 jmp_table64:
 	$(CXX) $(CFLAGS) jmp_table.cpp -o $@ -m64
+memfd:
+	$(CXX) $(CFLAGS) memfd.cpp -o $@ -m64
 profiler: profiler.cpp ../xbyak/xbyak_util.h
 	$(CXX) $(CFLAGS) profiler.cpp -o $@
 profiler-vtune: profiler.cpp ../xbyak/xbyak_util.h
@@ -121,3 +124,4 @@
 test_util2 : test_util.cpp $(XBYAK_INC) ../xbyak/xbyak_util.h
 jmp_table: jmp_table.cpp $(XBYAK_INC)
 jmp_table64: jmp_table.cpp $(XBYAK_INC)
+memfd: memfd.cpp $(XBYAK_INC)

=== test/Makefile ===
TARGET = make_nm normalize_prefix bad_address misc cvt_test cvt_test32 noexception misc32
XBYAK_INC=../xbyak/xbyak.h
UNAME_S=$(shell uname -s)
BIT=32
ifeq ($(shell uname -m),x86_64)
BIT=64
endif
ONLY_64BIT=0
ifeq ($(UNAME_S),Darwin)
  # 32-bit binary is not supported
  ONLY_64BIT=1
endif
ifeq ($(ONLY_64BIT),0)
  TARGET += jmp address
endif

ifeq ($(BIT),64)
	TARGET += jmp64 address64
endif

all: $(TARGET)

CFLAGS_WARN=-Wall -Wextra -Wformat=2 -Wcast-qual -Wcast-align -Wwrite-strings -Wfloat-equal -Wpointer-arith

CFLAGS=-O2 -fomit-frame-pointer -Wall -fno-operator-names -I../ -I./ $(CFLAGS_WARN) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) #-std=c++0x
make_nm:
	$(CXX) $(CFLAGS) make_nm.cpp -o $@
normalize_prefix: normalize_prefix.cpp ../xbyak/xbyak.h
	$(CXX) $(CFLAGS) normalize_prefix.cpp -o $@
test_mmx: test_mmx.cpp ../xbyak/xbyak.h
	$(CXX) $(CFLAGS) test_mmx.cpp -o $@ -lpthread
jmp: jmp.cpp ../xbyak/xbyak.h
	$(CXX) $(CFLAGS) jmp.cpp -o $@ -m32
jmp64: jmp.cpp ../xbyak/xbyak.h
	$(CXX) $(CFLAGS) jmp.cpp -o $@ -m64
address: address.cpp ../xbyak/xbyak.h
	$(CXX) $(CFLAGS) address.cpp -o $@ -m32
address64: address.cpp ../xbyak/xbyak.h
	$(CXX) $(CFLAGS) address.cpp -o $@ -m64
bad_address: bad_address.cpp ../xbyak/xbyak.h
	$(CXX) $(CFLAGS) bad_address.cpp -o $@
misc: misc.cpp ../xbyak/xbyak.h
	$(CXX) $(CFLAGS) misc.cpp -o $@
misc32: misc.cpp ../xbyak/xbyak.h
	$(CXX) $(CFLAGS) misc.cpp -o $@ -DXBYAK32
cvt_test: cvt_test.cpp ../xbyak/xbyak.h
	$(CXX) $(CFLAGS) $< -o $@
cvt_test32: cvt_test.cpp ../xbyak/xbyak.h
	$(CXX) $(CFLAGS) $< -o $@ -DXBYAK32
noexception: noexception.cpp ../xbyak/xbyak.h
	$(CXX) $(CFLAGS) $< -o $@ -fno-exceptions

test_nm: normalize_prefix $(TARGET)
	$(MAKE) -C ../gen
ifneq ($(ONLY_64BIT),1)
	./test_nm.sh
	./test_nm.sh noexcept
	./noexception
	./test_nm.sh Y
	./test_nm.sh avx512
	./test_address.sh
	./jmp
	./cvt_test32
endif
	./bad_address
	./misc
	./misc32
	./cvt_test
ifeq ($(BIT),64)
	./test_address.sh 64
	./test_nm.sh 64
	./test_nm.sh Y64
	./jmp64
endif

test_avx: normalize_prefix
ifneq ($(ONLY_64BIT),0)
	./test_avx.sh
	./test_avx.sh Y
endif
ifeq ($(BIT),64)
	./test_address.sh 64
	./test_avx.sh 64
	./test_avx.sh Y64
endif

test_avx512: normalize_prefix
ifneq ($(ONLY_64BIT),0)
	./test_avx512.sh
endif
ifeq ($(BIT),64)
	./test_avx512.sh 64
endif

test:
	$(MAKE) test_nm
	$(MAKE) test_avx
	$(MAKE) test_avx512

clean:
	$(RM) a.asm *.lst *.obj *.o $(TARGET) lib_run nm.cpp nm_frame make_512

lib_run: lib_test.cpp lib_run.cpp lib.h
	$(CXX) $(CFLAGS) lib_run.cpp lib_test.cpp -o lib_run
make_nm: make_nm.cpp $(XBYAK_INC)

=== debian/changelog ===
xbyak (6.63-1) unstable; urgency=medium

  * New upstream version 6.63

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 09 Oct 2022 13:16:09 +0200

xbyak (6.62-1) unstable; urgency=medium

  * New upstream version 6.62
  * d/rules: use execute_after_*

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sat, 17 Sep 2022 14:10:45 +0200

=== debian/rules ===
--- 
+++ 
@@ -15,19 +15,14 @@
   bits := 64
 endif
 
-override_dh_auto_build-arch:
-	dh_auto_build
+execute_after_dh_auto_build-arch:
 	make -C sample BIT=$(bits)
 	make -C test BIT=$(bits)
 
-override_dh_auto_test:
-	dh_auto_test
-	uname -m
-	dpkg --print-architecture
+execute_after_dh_auto_test:
 	make -C test BIT=$(bits) test
 
-override_dh_auto_clean:
-	dh_auto_clean
+execute_after_dh_auto_clean:
 	make -C sample BIT=$(bits) clean
 	make -C test BIT=$(bits) clean
 	$(RM) gen/gen_avx512 gen/gen_code gen/sortline

## xbyak 6.64

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.63)
+project(xbyak LANGUAGES CXX VERSION 6.64)
 
 file(GLOB headers xbyak/*.h)

=== debian/changelog ===
xbyak (6.64-2) unstable; urgency=medium

  * d/patches: x32 support

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 20 Nov 2022 15:26:15 +0100

xbyak (6.64-1) unstable; urgency=medium

  * New upstream version 6.64

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 06 Nov 2022 22:04:09 +0100

## xbyak 6.65

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.64)
+project(xbyak LANGUAGES CXX VERSION 6.65)
 
 file(GLOB headers xbyak/*.h)

=== test/Makefile ===
--- 
+++ 
@@ -1,6 +1,9 @@
-TARGET = make_nm normalize_prefix bad_address misc cvt_test cvt_test32 noexception misc32
+TARGET = make_nm normalize_prefix bad_address misc cvt_test cvt_test32 noexception misc32 detect_x32
 XBYAK_INC=../xbyak/xbyak.h
 UNAME_S=$(shell uname -s)
+ifeq ($(shell ./detect_x32),x32)
+X32=1
+endif
 BIT=32
 ifeq ($(shell uname -m),x86_64)
 BIT=64
@@ -68,8 +71,10 @@
 	./cvt_test
 ifeq ($(BIT),64)
 	./test_address.sh 64
+ifneq ($(X32),1)
 	./test_nm.sh 64
 	./test_nm.sh Y64
+endif
 	./jmp64
 endif
 
@@ -79,9 +84,10 @@
 	./test_avx.sh Y
 endif
 ifeq ($(BIT),64)
-	./test_address.sh 64
 	./test_avx.sh 64
+ifneq ($(X32),1)
 	./test_avx.sh Y64
+endif
 endif
 
 test_avx512: normalize_prefix
@@ -92,7 +98,10 @@
 	./test_avx512.sh 64
 endif
 
-test:
+detect_x32: detect_x32.c
+	$(CC) $< -o $@
+
+test: detect_x32
 	$(MAKE) test_nm
 	$(MAKE) test_avx
 	$(MAKE) test_avx512
@@ -104,4 +113,3 @@
 	$(CXX) $(CFLAGS) lib_run.cpp lib_test.cpp -o lib_run
 make_nm: make_nm.cpp $(XBYAK_INC)
 
-

=== debian/changelog ===
xbyak (6.65-1) unstable; urgency=medium

  * New upstream version 6.65
  * d/patches: drop upstreamed patches
  * d/rules: use DEB_HOST_ARCH_BITS for pointer size

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 24 Nov 2022 16:23:34 +0100

## xbyak 6.66

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.65)
+project(xbyak LANGUAGES CXX VERSION 6.66)
 
 file(GLOB headers xbyak/*.h)

=== sample/Makefile ===
--- 
+++ 
@@ -1,6 +1,9 @@
 XBYAK_INC=../xbyak/xbyak.h
+CXX?=g++
 
-BOOST_EXIST=$(shell echo "\#include <boost/spirit/core.hpp>" | (gcc -E - 2>/dev/null) | grep "boost/spirit/core.hpp" >/dev/null && echo "1")
+#BOOST_EXIST=$(shell echo "#include <boost/spirit/core.hpp>" | $CXX -x c++ -c - 2>/dev/null && echo 1)
+# I don't know why the above code causes an error on GitHub action.
+BOOST_EXIST?=0
 UNAME_M=$(shell uname -m)
 
 ONLY_64BIT=0
@@ -104,7 +107,7 @@
 	$(CXX) $(CFLAGS) profiler.cpp -o $@ -DXBYAK_USE_VTUNE -I /opt/intel/vtune_amplifier/include/ -L /opt/intel/vtune_amplifier/lib64 -ljitprofiling -ldl
 
 clean:
-	rm -rf *.o $(TARGET) *.exe profiler profiler-vtune
+	rm -rf $(TARGET) profiler profiler-vtune
 
 test : test0.cpp $(XBYAK_INC)
 test64: test0.cpp $(XBYAK_INC)

=== debian/changelog ===
xbyak (6.66-1) unstable; urgency=medium

  * New upstream version 6.66

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 28 Nov 2022 15:24:52 +0100

=== debian/watch ===
version=4
opts="searchmode=plain, \
  filenamemangle=s/.+\/v@ANY_VERSION@/@PACKAGE@-$1\.tar\.gz/, \
  pgpmode=none" \
https://api.github.com/repos/herumi/xbyak/tags \
https://api.github.com/repos/herumi/xbyak/tarball/refs/tags/v@ANY_VERSION@

## xbyak 6.67

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.66)
+project(xbyak LANGUAGES CXX VERSION 6.67)
 
 file(GLOB headers xbyak/*.h)

=== gen/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 TARGET=../xbyak/xbyak_mnemonic.h
 BIN=sortline gen_code gen_avx512
-CFLAGS=-I../ -O2 -DXBYAK_NO_OP_NAMES -Wall -Wextra -Wno-missing-field-initializers $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS)
+CFLAGS=-I../ -O2 -Wall -Wextra -Wno-missing-field-initializers $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS)
 all: $(TARGET) ../CMakeLists.txt ../meson.build ../readme.md ../readme.txt
 sortline: sortline.cpp
 	$(CXX) $(CFLAGS) $< -o $@

=== sample/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 XBYAK_INC=../xbyak/xbyak.h
 CXX?=g++
 
-#BOOST_EXIST=$(shell echo "#include <boost/spirit/core.hpp>" | $CXX -x c++ -c - 2>/dev/null && echo 1)
+#BOOST_EXIST=$(shell echo "#include <boost/spirit/core.hpp>" | $(CXX) -x c++ -c - 2>/dev/null && echo 1)
 # I don't know why the above code causes an error on GitHub action.
 BOOST_EXIST?=0
 UNAME_M=$(shell uname -m)

=== test/Makefile ===
--- 
+++ 
@@ -23,9 +23,9 @@
 
 all: $(TARGET)
 
-CFLAGS_WARN=-Wall -Wextra -Wformat=2 -Wcast-qual -Wcast-align -Wwrite-strings -Wfloat-equal -Wpointer-arith
+CFLAGS_WARN=-Wall -Wextra -Wformat=2 -Wcast-qual -Wwrite-strings -Wfloat-equal -Wpointer-arith
 
-CFLAGS=-O2 -fomit-frame-pointer -Wall -fno-operator-names -I../ -I./ $(CFLAGS_WARN) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) #-std=c++0x
+CFLAGS=-O2 -Wall -I../ -I./ $(CFLAGS_WARN) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) #-std=c++0x
 make_nm:
 	$(CXX) $(CFLAGS) make_nm.cpp -o $@
 normalize_prefix: normalize_prefix.cpp ../xbyak/xbyak.h
@@ -56,12 +56,11 @@
 test_nm: normalize_prefix $(TARGET)
 	$(MAKE) -C ../gen
 ifneq ($(ONLY_64BIT),1)
-	./test_nm.sh
-	./test_nm.sh noexcept
-	./noexception
-	./test_nm.sh Y
-	./test_nm.sh avx512
-	./test_address.sh
+	env CXX=$(CXX) sh -e ./test_nm.sh
+	env CXX=$(CXX) sh -e ./test_nm.sh noexcept
+	env CXX=$(CXX) sh -e ./test_nm.sh Y
+	env CXX=$(CXX) sh -e ./test_nm.sh avx512
+	env CXX=$(CXX) sh -e ./test_address.sh
 	./jmp
 	./cvt_test32
 endif
@@ -70,32 +69,32 @@
 	./misc32
 	./cvt_test
 ifeq ($(BIT),64)
-	./test_address.sh 64
+	env CXX=$(CXX) sh -e ./test_address.sh 64
 ifneq ($(X32),1)
-	./test_nm.sh 64
-	./test_nm.sh Y64
+	env CXX=$(CXX) sh -e ./test_nm.sh 64
+	env CXX=$(CXX) sh -e ./test_nm.sh Y64
 endif
 	./jmp64
 endif
 
 test_avx: normalize_prefix
 ifneq ($(ONLY_64BIT),0)
-	./test_avx.sh
-	./test_avx.sh Y
+	env CXX=$(CXX) sh -e ./test_avx.sh
+	env CXX=$(CXX) sh -e ./test_avx.sh Y
 endif
 ifeq ($(BIT),64)
-	./test_avx.sh 64
+	env CXX=$(CXX) sh -e ./test_avx.sh 64
 ifneq ($(X32),1)
-	./test_avx.sh Y64
+	env CXX=$(CXX) sh -e ./test_avx.sh Y64
 endif
 endif
 
 test_avx512: normalize_prefix
 ifneq ($(ONLY_64BIT),0)
-	./test_avx512.sh
+	env CXX=$(CXX) sh -e ./test_avx512.sh
 endif
 ifeq ($(BIT),64)
-	./test_avx512.sh 64
+	env CXX=$(CXX) sh -e ./test_avx512.sh 64
 endif
 
 detect_x32: detect_x32.c

=== debian/changelog ===
xbyak (6.67-1) unstable; urgency=medium

  * New upstream version 6.67

 -- Andrea Pappacoda <andrea@pappacoda.it>  Thu, 01 Dec 2022 20:04:53 +0100

## xbyak 6.68

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.67)
+project(xbyak LANGUAGES CXX VERSION 6.68)
 
 file(GLOB headers xbyak/*.h)

=== sample/Makefile ===
--- 
+++ 
@@ -1,9 +1,7 @@
 XBYAK_INC=../xbyak/xbyak.h
 CXX?=g++
 
-#BOOST_EXIST=$(shell echo "#include <boost/spirit/core.hpp>" | $(CXX) -x c++ -c - 2>/dev/null && echo 1)
-# I don't know why the above code causes an error on GitHub action.
-BOOST_EXIST?=0
+BOOST_EXIST=$(shell echo "#include <boost/spirit/core.hpp>" | $(CXX) -x c++ -c - 2>/dev/null && echo 1)
 UNAME_M=$(shell uname -m)
 
 ONLY_64BIT=0

=== test/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 XBYAK_INC=../xbyak/xbyak.h
 UNAME_S=$(shell uname -s)
 ifeq ($(shell ./detect_x32),x32)
-X32=1
+X32?=1
 endif
 BIT=32
 ifeq ($(shell uname -m),x86_64)
@@ -56,11 +56,11 @@
 test_nm: normalize_prefix $(TARGET)
 	$(MAKE) -C ../gen
 ifneq ($(ONLY_64BIT),1)
-	env CXX=$(CXX) sh -e ./test_nm.sh
-	env CXX=$(CXX) sh -e ./test_nm.sh noexcept
-	env CXX=$(CXX) sh -e ./test_nm.sh Y
-	env CXX=$(CXX) sh -e ./test_nm.sh avx512
-	env CXX=$(CXX) sh -e ./test_address.sh
+	CXX=$(CXX) ./test_nm.sh
+	CXX=$(CXX) ./test_nm.sh noexcept
+	CXX=$(CXX) ./test_nm.sh Y
+	CXX=$(CXX) ./test_nm.sh avx512
+	CXX=$(CXX) ./test_address.sh
 	./jmp
 	./cvt_test32
 endif
@@ -69,32 +69,32 @@
 	./misc32
 	./cvt_test
 ifeq ($(BIT),64)
-	env CXX=$(CXX) sh -e ./test_address.sh 64
+	CXX=$(CXX) ./test_address.sh 64
 ifneq ($(X32),1)
-	env CXX=$(CXX) sh -e ./test_nm.sh 64
-	env CXX=$(CXX) sh -e ./test_nm.sh Y64
+	CXX=$(CXX) ./test_nm.sh 64
+	CXX=$(CXX) ./test_nm.sh Y64
 endif
 	./jmp64
 endif
 
 test_avx: normalize_prefix
 ifneq ($(ONLY_64BIT),0)
-	env CXX=$(CXX) sh -e ./test_avx.sh
-	env CXX=$(CXX) sh -e ./test_avx.sh Y
+	CXX=$(CXX) ./test_avx.sh
+	CXX=$(CXX) ./test_avx.sh Y
 endif
 ifeq ($(BIT),64)
-	env CXX=$(CXX) sh -e ./test_avx.sh 64
+	CXX=$(CXX) ./test_avx.sh 64
 ifneq ($(X32),1)
-	env CXX=$(CXX) sh -e ./test_avx.sh Y64
+	CXX=$(CXX) ./test_avx.sh Y64
 endif
 endif
 
 test_avx512: normalize_prefix
 ifneq ($(ONLY_64BIT),0)
-	env CXX=$(CXX) sh -e ./test_avx512.sh
+	CXX=$(CXX) ./test_avx512.sh
 endif
 ifeq ($(BIT),64)
-	env CXX=$(CXX) sh -e ./test_avx512.sh 64
+	CXX=$(CXX) ./test_avx512.sh 64
 endif
 
 detect_x32: detect_x32.c

=== debian/changelog ===
xbyak (6.68-1) unstable; urgency=medium

  * New upstream version 6.68

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 14 Dec 2022 18:24:27 +0100

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,14 @@
 Section: libdevel
 Priority: optional
 Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
-Build-Depends: debhelper-compat (= 13),
-               meson (>= 0.50),
-               cmake
-Build-Depends-Arch: g++-multilib <!nocheck>,
+Build-Depends: debhelper-compat (= 13)
+Build-Depends-Arch: meson (>= 0.50),
+                    cmake,
+                    g++-multilib <!nocheck>,
                     libboost-dev <!nocheck>,
                     nasm <!nocheck>,
                     yasm <!nocheck>
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/herumi/xbyak
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian/xbyak.git

## xbyak 6.69.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.68)
+project(xbyak LANGUAGES CXX VERSION 6.69.2)
 
 file(GLOB headers xbyak/*.h)

=== debian/changelog ===
xbyak (6.69.2-1) unstable; urgency=medium

  * New upstream version 6.69.2
  * Upload to unstable

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 04 Jul 2023 15:11:18 +0200

xbyak (6.69.1-1) experimental; urgency=medium

  * New upstream version 6.69.1

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 22 May 2023 01:18:41 +0200

## xbyak 6.70

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 2.6...3.0.2)
 
-project(xbyak LANGUAGES CXX VERSION 6.69.2)
+project(xbyak LANGUAGES CXX VERSION 6.70)
 
 file(GLOB headers xbyak/*.h)

=== debian/changelog ===
xbyak (6.70-1) unstable; urgency=medium

  * New upstream version 6.70

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 11 Jul 2023 17:03:25 +0200

## xbyak 6.73

=== sample/Makefile ===
--- 
+++ 
@@ -122,7 +122,7 @@
 static_buf: static_buf.cpp $(XBYAK_INC)
 static_buf64: static_buf.cpp $(XBYAK_INC)
 test_util : test_util.cpp $(XBYAK_INC) ../xbyak/xbyak_util.h
-test_util2 : test_util.cpp $(XBYAK_INC) ../xbyak/xbyak_util.h
+test_util64 : test_util.cpp $(XBYAK_INC) ../xbyak/xbyak_util.h
 jmp_table: jmp_table.cpp $(XBYAK_INC)
 jmp_table64: jmp_table.cpp $(XBYAK_INC)
 memfd: memfd.cpp $(XBYAK_INC)

=== test/Makefile ===
--- 
+++ 
@@ -13,6 +13,9 @@
   # 32-bit binary is not supported
   ONLY_64BIT=1
 endif
+ifeq ($(findstring MINGW64,$(UNAME_S)),MINGW64)
+  ONLY_64BIT=1
+endif
 ifeq ($(ONLY_64BIT),0)
   TARGET += jmp address
 endif
@@ -25,7 +28,7 @@
 
 CFLAGS_WARN=-Wall -Wextra -Wformat=2 -Wcast-qual -Wwrite-strings -Wfloat-equal -Wpointer-arith
 
-CFLAGS=-O2 -Wall -I../ -I./ $(CFLAGS_WARN) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) #-std=c++0x
+CFLAGS=-O2 -Wall -I.. -I. $(CFLAGS_WARN) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) #-std=c++0x
 make_nm:
 	$(CXX) $(CFLAGS) make_nm.cpp -o $@
 normalize_prefix: normalize_prefix.cpp ../xbyak/xbyak.h
@@ -112,3 +115,4 @@
 	$(CXX) $(CFLAGS) lib_run.cpp lib_test.cpp -o lib_run
 make_nm: make_nm.cpp $(XBYAK_INC)
 
+.PHONY: test

=== debian/changelog ===
xbyak (6.73-1) unstable; urgency=medium

  * New upstream version 6.73
    - Huge pages support
    - Add sha512/sm3/sm4/avx-vnni-int16
    - Add xbegin/xabort/xend

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 12 Sep 2023 15:32:15 +0200

## xbyak 7.02

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(xbyak LANGUAGES CXX VERSION 7.02)

file(GLOB headers xbyak/*.h)

include(GNUInstallDirs)
add_library(${PROJECT_NAME} INTERFACE)
add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

target_include_directories(
	${PROJECT_NAME} INTERFACE
	"$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
	"$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
)

install(
	TARGETS ${PROJECT_NAME}
	EXPORT ${PROJECT_NAME}-targets
	INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}
)

include(CMakePackageConfigHelpers)
configure_package_config_file(
	cmake/config.cmake.in
	"${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
	INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)
write_basic_package_version_file(
	"${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
	COMPATIBILITY SameMajorVersion
)

install(
	FILES
		"${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
		"${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
	DESTINATION
		${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)

install(
	EXPORT ${PROJECT_NAME}-targets
	NAMESPACE ${PROJECT_NAME}::
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)

install(
	FILES ${headers}
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xbyak
)

=== debian/changelog ===
xbyak (7.02-1) unstable; urgency=medium

  * New upstream version 7.02
  * Upload to unstable
  * d/patches: drop upstreamed patches

 -- Andrea Pappacoda <andrea@pappacoda.it>  Sun, 24 Dec 2023 13:13:15 +0100

xbyak (7.00-1) experimental; urgency=medium

  * New upstream version 7.00
  * d/patches: fix tests on 32 bit systems

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 11 Dec 2023 19:49:37 +0100

## xbyak 7.05

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.5)
 
-project(xbyak LANGUAGES CXX VERSION 7.02)
+project(xbyak LANGUAGES CXX VERSION 7.05)
 
 file(GLOB headers xbyak/*.h)

=== Makefile ===
PREFIX?=/usr/local
INSTALL_DIR=$(PREFIX)/include/xbyak

all:
	$(MAKE) -C sample

clean:
	$(MAKE) -C sample clean

install:
	mkdir -p $(INSTALL_DIR)
	cp -pR xbyak/*.h $(INSTALL_DIR)

uninstall:
	rm -i $(INSTALL_DIR)/*.h
	rmdir $(INSTALL_DIR)

update:
	$(MAKE) -C gen

test:
	$(MAKE) -C test test

.PHONY: test update

=== test/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 TARGET = make_nm normalize_prefix bad_address misc cvt_test cvt_test32 noexception misc32 detect_x32
-XBYAK_INC=../xbyak/xbyak.h
+XBYAK_INC=../xbyak/xbyak.h ../xbyak/xbyak_mnemonic.h
 UNAME_S=$(shell uname -s)
 ifeq ($(shell ./detect_x32),x32)
 X32?=1
@@ -21,7 +21,7 @@
 endif
 
 ifeq ($(BIT),64)
-	TARGET += jmp64 address64
+	TARGET += jmp64 address64 apx
 endif
 
 all: $(TARGET)
@@ -31,30 +31,32 @@
 CFLAGS=-O2 -Wall -I.. -I. $(CFLAGS_WARN) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) #-std=c++0x
 make_nm:
 	$(CXX) $(CFLAGS) make_nm.cpp -o $@
-normalize_prefix: normalize_prefix.cpp ../xbyak/xbyak.h
+normalize_prefix: normalize_prefix.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) normalize_prefix.cpp -o $@
-test_mmx: test_mmx.cpp ../xbyak/xbyak.h
+test_mmx: test_mmx.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) test_mmx.cpp -o $@ -lpthread
-jmp: jmp.cpp ../xbyak/xbyak.h
+jmp: jmp.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) jmp.cpp -o $@ -m32
-jmp64: jmp.cpp ../xbyak/xbyak.h
+jmp64: jmp.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) jmp.cpp -o $@ -m64
-address: address.cpp ../xbyak/xbyak.h
+address: address.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) address.cpp -o $@ -m32
-address64: address.cpp ../xbyak/xbyak.h
+address64: address.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) address.cpp -o $@ -m64
-bad_address: bad_address.cpp ../xbyak/xbyak.h
+bad_address: bad_address.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) bad_address.cpp -o $@
-misc: misc.cpp ../xbyak/xbyak.h
+misc: misc.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) misc.cpp -o $@
-misc32: misc.cpp ../xbyak/xbyak.h
+misc32: misc.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) misc.cpp -o $@ -DXBYAK32
-cvt_test: cvt_test.cpp ../xbyak/xbyak.h
+cvt_test: cvt_test.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) $< -o $@
-cvt_test32: cvt_test.cpp ../xbyak/xbyak.h
+cvt_test32: cvt_test.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) $< -o $@ -DXBYAK32
-noexception: noexception.cpp ../xbyak/xbyak.h
+noexception: noexception.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) $< -o $@ -fno-exceptions
+apx: apx.cpp $(XBYAK_INC)
+	$(CXX) $(CFLAGS) apx.cpp -o $@
 
 test_nm: normalize_prefix $(TARGET)
 	$(MAKE) -C ../gen
@@ -78,6 +80,7 @@
 	CXX=$(CXX) ./test_nm.sh Y64
 endif
 	./jmp64
+	./apx
 endif
 
 test_avx: normalize_prefix

=== debian/changelog ===
xbyak (7.05-1) unstable; urgency=medium

  * New upstream version 7.05

 -- Andrea Pappacoda <andrea@pappacoda.it>  Fri, 12 Jan 2024 10:01:26 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                     libboost-dev <!nocheck>,
                     nasm <!nocheck>,
                     yasm <!nocheck>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/herumi/xbyak
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian/xbyak.git

## xbyak 7.07.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.5)
 
-project(xbyak LANGUAGES CXX VERSION 7.05)
+project(xbyak LANGUAGES CXX VERSION 7.07.1)
 
 file(GLOB headers xbyak/*.h)

=== debian/changelog ===
xbyak (7.07.1-1) unstable; urgency=medium

  * New upstream version 7.07.1
    - Closes: #1080144
  * First dgit upload
  * d/README.source: document packaging workflow
  * d/control: declare dpkg-build-api = 1
  * d/control: apply X-Style: black

 -- Andrea Pappacoda <andrea@pappacoda.it>  Mon, 02 Sep 2024 09:49:39 +0200

## xbyak 7.22

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.5)
 
-project(xbyak LANGUAGES CXX VERSION 7.07.1)
+project(xbyak LANGUAGES CXX VERSION 7.22)
 
 file(GLOB headers xbyak/*.h)

=== test/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-TARGET = make_nm normalize_prefix bad_address misc cvt_test cvt_test32 noexception misc32 detect_x32
+TARGET = make_nm normalize_prefix bad_address misc cvt_test cvt_test32 noexception misc32 detect_x32 avx10_test
 XBYAK_INC=../xbyak/xbyak.h ../xbyak/xbyak_mnemonic.h
 UNAME_S=$(shell uname -s)
 ifeq ($(shell ./detect_x32),x32)
@@ -57,6 +57,15 @@
 	$(CXX) $(CFLAGS) $< -o $@ -fno-exceptions
 apx: apx.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) apx.cpp -o $@
+avx10_test: avx10_test.cpp $(XBYAK_INC)
+	$(CXX) $(CFLAGS) avx10_test.cpp -o $@ -DXBYAK64
+
+TEST_FILES=old.txt new-ymm.txt bf16.txt comp.txt misc.txt convert.txt minmax.txt saturation.txt
+xed_test:
+	@set -e; \
+	for target in $(addprefix avx10/, $(TEST_FILES)); do \
+		./test_by_xed.sh $$target || exit 1; \
+	done
 
 test_nm: normalize_prefix $(TARGET)
 	$(MAKE) -C ../gen
@@ -81,6 +90,7 @@
 endif
 	./jmp64
 	./apx
+	./avx10_test
 endif
 
 test_avx: normalize_prefix
@@ -103,6 +113,9 @@
 	CXX=$(CXX) ./test_avx512.sh 64
 endif
 
+test_avx10: avx10_test
+	./avx10_test
+
 detect_x32: detect_x32.c
 	$(CC) $< -o $@
 
@@ -112,7 +125,7 @@
 	$(MAKE) test_avx512
 
 clean:
-	$(RM) a.asm *.lst *.obj *.o $(TARGET) lib_run nm.cpp nm_frame make_512
+	$(RM) a.asm *.lst *.obj *.o $(TARGET) lib_run nm.cpp nm_frame make_512 avx10_test detect_x32
 
 lib_run: lib_test.cpp lib_run.cpp lib.h
 	$(CXX) $(CFLAGS) lib_run.cpp lib_test.cpp -o lib_run

=== debian/changelog ===
xbyak (7.22-1) unstable; urgency=low

  * New upstream version 7.22

 -- Andrea Pappacoda <andrea@pappacoda.it>  Tue, 14 Jan 2025 23:22:26 +0100

=== debian/control ===
Source: xbyak
Section: libdevel
Priority: optional
Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-build-api (= 1),
Build-Depends-Arch:
 cmake,
 g++-multilib <!nocheck>,
 libboost-dev <!nocheck>,
 meson (>= 0.50),
 nasm <!nocheck>,
 yasm <!nocheck>,
Standards-Version: 4.7.0
Homepage: https://github.com/herumi/xbyak
Vcs-Git: https://salsa.debian.org/debian/xbyak.git
Vcs-Browser: https://salsa.debian.org/debian/xbyak
X-Style: black

Package: libxbyak-dev
Architecture: any-amd64 any-i386
Depends:
 ${misc:Depends},
Description: JIT assembler for x86(IA32), x64(AMD64, x86-64)
 Xbyak is a C++ header library that enables dynamically to assemble
 x86(IA32), x64(AMD64, x86-64) mnemonic.
 .
 The library supports any compiler supporting C++03 or later.
 .
 This package contains the development headers.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all qa=+all
# -Werror=array-bounds: added by qa=+bug, triggers some false positives
export DEB_CXXFLAGS_MAINT_STRIP = -Werror=array-bounds

%:
	dh $@ --buildsystem=meson

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

execute_after_dh_auto_build-arch:
	make -C sample BIT=$(DEB_HOST_ARCH_BITS)
	make -C test BIT=$(DEB_HOST_ARCH_BITS)

execute_after_dh_auto_test:
	make -C test BIT=$(DEB_HOST_ARCH_BITS) test

execute_after_dh_auto_clean:
	make -C sample BIT=$(DEB_HOST_ARCH_BITS) clean
	make -C test BIT=$(DEB_HOST_ARCH_BITS) clean
	$(RM) gen/gen_avx512 gen/gen_code gen/sortline

endif

## xbyak 7.24.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 
-project(xbyak LANGUAGES CXX VERSION 7.22)
+project(xbyak LANGUAGES CXX VERSION 7.24.2)
 
 file(GLOB headers xbyak/*.h)

=== sample/Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 endif
 
 ifeq ($(BIT),64)
-TARGET += test64 bf64 memfunc64 test_util64 jmp_table64
+TARGET += test64 bf64 memfunc64 test_util64 jmp_table64 zero_upper ccmp no_flags
 ifeq ($(BOOST_EXIST),1)
 TARGET += calc64 #calc2_64
 endif
@@ -103,6 +103,18 @@
 	$(CXX) $(CFLAGS) profiler.cpp -o $@
 profiler-vtune: profiler.cpp ../xbyak/xbyak_util.h
 	$(CXX) $(CFLAGS) profiler.cpp -o $@ -DXBYAK_USE_VTUNE -I /opt/intel/vtune_amplifier/include/ -L /opt/intel/vtune_amplifier/lib64 -ljitprofiling -ldl
+zero_upper: zero_upper.cpp $(XBYAK_INC)
+	$(CXX) $(CFLAGS) zero_upper.cpp -o $@
+test_zero_upper: zero_upper
+	sde -future -- ./zero_upper
+ccmp: ccmp.cpp $(XBYAK_INC)
+	$(CXX) $(CFLAGS) ccmp.cpp -o $@
+test_ccmp: ccmp
+	sde -future -- ./ccmp
+no_flags: no_flags.cpp $(XBYAK_INC)
+	$(CXX) $(CFLAGS) no_flags.cpp -o $@
+test_no_flags: no_flags
+	sde -future -- ./no_flags
 
 clean:
 	rm -rf $(TARGET) profiler profiler-vtune

=== test/Makefile ===
--- 
+++ 
@@ -1,5 +1,7 @@
+# To compile with -m32
+# apt install g++-multilib
 TARGET = make_nm normalize_prefix bad_address misc cvt_test cvt_test32 noexception misc32 detect_x32 avx10_test
-XBYAK_INC=../xbyak/xbyak.h ../xbyak/xbyak_mnemonic.h
+XBYAK_INC=../xbyak/xbyak.h ../xbyak/xbyak_mnemonic.h ../xbyak/xbyak_util.h
 UNAME_S=$(shell uname -s)
 ifeq ($(shell ./detect_x32),x32)
 X32?=1
@@ -22,6 +24,7 @@
 
 ifeq ($(BIT),64)
 	TARGET += jmp64 address64 apx
+	TARGET += sf_test
 endif
 
 all: $(TARGET)
@@ -36,19 +39,19 @@
 test_mmx: test_mmx.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) test_mmx.cpp -o $@ -lpthread
 jmp: jmp.cpp $(XBYAK_INC)
-	$(CXX) $(CFLAGS) jmp.cpp -o $@ -m32
+	$(CXX) $(CFLAGS) $< -o $@ -m32
 jmp64: jmp.cpp $(XBYAK_INC)
-	$(CXX) $(CFLAGS) jmp.cpp -o $@ -m64
+	$(CXX) $(CFLAGS) $< -o $@ -m64
 address: address.cpp $(XBYAK_INC)
-	$(CXX) $(CFLAGS) address.cpp -o $@ -m32
+	$(CXX) $(CFLAGS) $< -o $@ -m32
 address64: address.cpp $(XBYAK_INC)
-	$(CXX) $(CFLAGS) address.cpp -o $@ -m64
+	$(CXX) $(CFLAGS) $< -o $@ -m64
 bad_address: bad_address.cpp $(XBYAK_INC)
-	$(CXX) $(CFLAGS) bad_address.cpp -o $@
+	$(CXX) $(CFLAGS) $< -o $@
 misc: misc.cpp $(XBYAK_INC)
-	$(CXX) $(CFLAGS) misc.cpp -o $@
+	$(CXX) $(CFLAGS) $< -o $@
 misc32: misc.cpp $(XBYAK_INC)
-	$(CXX) $(CFLAGS) misc.cpp -o $@ -DXBYAK32
+	$(CXX) $(CFLAGS) $< -o $@ -DXBYAK32
 cvt_test: cvt_test.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) $< -o $@
 cvt_test32: cvt_test.cpp $(XBYAK_INC)
@@ -56,11 +59,13 @@
 noexception: noexception.cpp $(XBYAK_INC)
 	$(CXX) $(CFLAGS) $< -o $@ -fno-exceptions
 apx: apx.cpp $(XBYAK_INC)
-	$(CXX) $(CFLAGS) apx.cpp -o $@
+	$(CXX) $(CFLAGS) $< -o $@
 avx10_test: avx10_test.cpp $(XBYAK_INC)
-	$(CXX) $(CFLAGS) avx10_test.cpp -o $@ -DXBYAK64
+	$(CXX) $(CFLAGS) $< -o $@ -DXBYAK64
+sf_test: sf_test.cpp $(XBYAK_INC)
+	$(CXX) $(CFLAGS) $< -o $@ -DXBYAK64
 
-TEST_FILES=old.txt new-ymm.txt bf16.txt comp.txt misc.txt convert.txt minmax.txt saturation.txt
+TEST_FILES=old.txt new-ymm.txt bf16.txt comp.txt misc.txt convert.txt minmax.txt saturation.txt apx.txt
 xed_test:
 	@set -e; \
 	for target in $(addprefix avx10/, $(TEST_FILES)); do \

=== debian/changelog ===
xbyak (7.24.2-3) unstable; urgency=medium

  * d/patches: update revert-strict-register-size-check.patch.
    Also disable a ERR_BAD_SIZE_OF_REGISTER check, which causes runtime
    failures in yuzu

 -- Andrea Pappacoda <tachi@debian.org>  Sat, 26 Apr 2025 01:40:07 +0200

xbyak (7.24.2-2) unstable; urgency=medium

  * d/patches: revert strict register size check (Closes: #1101630)

 -- Andrea Pappacoda <tachi@debian.org>  Wed, 02 Apr 2025 16:12:08 +0200

xbyak (7.24.2-1) unstable; urgency=low

  * New upstream version 7.24.2
  * d/control: use my @debian.org email address
  * d/{control,rules}: use cross toolchain instead of multilib.
    Thanks to Helmut for the suggestion!
  * d/patches: allow overriding $CXX -m32 and -m64

 -- Andrea Pappacoda <tachi@debian.org>  Wed, 26 Mar 2025 12:28:10 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,21 @@
 Source: xbyak
 Section: libdevel
 Priority: optional
-Maintainer: Andrea Pappacoda <andrea@pappacoda.it>
+Maintainer: Andrea Pappacoda <tachi@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  dpkg-build-api (= 1),
 Build-Depends-Arch:
  cmake,
- g++-multilib <!nocheck>,
+ g++-i686-linux-gnu [amd64] <!nocheck>,
+ g++-x86-64-linux-gnu [i386] <!nocheck>,
+ lib32stdc++6 [amd64] <!nocheck>,
  libboost-dev <!nocheck>,
+ libc6-i386 [amd64] <!nocheck>,
  meson (>= 0.50),
  nasm <!nocheck>,
  yasm <!nocheck>,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/herumi/xbyak
 Vcs-Git: https://salsa.debian.org/debian/xbyak.git
 Vcs-Browser: https://salsa.debian.org/debian/xbyak

=== debian/rules ===
--- 
+++ 
@@ -10,11 +10,11 @@
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 
 execute_after_dh_auto_build-arch:
-	make -C sample BIT=$(DEB_HOST_ARCH_BITS)
-	make -C test BIT=$(DEB_HOST_ARCH_BITS)
+	make -C sample BIT=$(DEB_HOST_ARCH_BITS) CXX_32=i686-linux-gnu-g++ CXX_64=x86_64-linux-gnu-g++
+	make -C test BIT=$(DEB_HOST_ARCH_BITS) CXX_32=i686-linux-gnu-g++ CXX_64=x86_64-linux-gnu-g++
 
 execute_after_dh_auto_test:
-	make -C test BIT=$(DEB_HOST_ARCH_BITS) test
+	make -C test BIT=$(DEB_HOST_ARCH_BITS) CXX_32=i686-linux-gnu-g++ CXX_64=x86_64-linux-gnu-g++ test
 
 execute_after_dh_auto_clean:
 	make -C sample BIT=$(DEB_HOST_ARCH_BITS) clean
